/**
 * All functions for manage interactions between father and chlid labels.
 */

function get_all_childs_of_father(tab_labels, father_id) {
    /**
     * Gets all the childs (label id) from a father.
     */
    var childs = [];
    for (var i = 0; tab_labels[i]; i++) {
        if (tab_labels[i][2] == father_id) {
            childs.push(tab_labels[i][0])
            childs = childs.concat(get_all_childs_of_father(tab_labels, tab_labels[i][0]));
        }
    }
    return (childs);
}

function get_all_fathers_of_child(tab_labels, child_id) {
    /**
     * Gets all the fathers (label id) of a child.
     */
    var fathers = [];
    var posi_child = is_in_tab(child_id, tab_labels, 0, 2);
    if (posi_child <= 0)
        return (fathers);
    for (var i = 0; tab_labels[i]; i++) {
        if (tab_labels[posi_child][2] == tab_labels[i][0]) {
            fathers.push(tab_labels[i][0]);
            fathers = fathers.concat(get_all_fathers_of_child(tab_labels, tab_labels[i][0]));
        }
    }
    return (fathers);
}

function get_all_childs_from_old(tab_labels, old_labels_tab) {
    /**
     * Put in array all label childs of every labels 
     * contain hierarchy.old_labels_tab.
     */
    var all_childs = [];
    for (var i = 0; old_labels_tab[i]; i++)
        all_childs = all_childs.concat(get_all_childs_of_father(tab_labels, old_labels_tab[i][0]));
    return (all_childs);
}

function remove_childs_of_tab(tab_id, all_labels) {
    /**
     * If there is a father with his child in new tab,
     * we have to keep just the father, not this childs.
     */
    var fathers = [];
    var in_tab = 0;
    var result = [];
    for (var i = 0; tab_id[i]; i++) {
        fathers = get_all_fathers_of_child(all_labels, tab_id[i]);
        if (fathers.length != 0) {
            for (var j = 0; fathers[j]; j++) {
                var posi = is_in_tab(fathers[j], tab_id, null, 1);
                if (posi != -1)
                    in_tab = 1;
            }
        }
        if (fathers.len == 0 || in_tab == 0)
            result.push(tab_id[i]);
        in_tab = 0;
    }
    return (result);
}

function add_father_to_child_tab(old_tab, childs_tab) {
    for (var i = 0; old_tab[i]; i++) 
        childs_tab += ','+old_tab[i][0];
    return (childs_tab);
}

function keep_the_oldest_father(labels_tab) {
    /**
     * If there is two labels in tab of the same family,
     * the oldest is keep. For example : Computer => [OS] => [free]
     * Ubuntu. We select OS between OS and free.
     */
     /*for (var i = 0; labels_tab[i]; i++)
        if (get_all_childs_of_father());*/
}